// Generated by CoffeeScript 1.9.0
(function() {
  var lookup, parse, states, statesReverse, _;

  _ = require('lodash');

  states = {
    AL: 'Alabama',
    AK: 'Alaska',
    AZ: 'Arizona',
    AR: 'Arkansas',
    CA: 'California',
    CO: 'Colorado',
    CT: 'Connecticut',
    DE: 'Delaware',
    FL: 'Florida',
    GA: 'Georgia',
    HI: 'Hawaii',
    ID: 'Idaho',
    IL: 'Illinois',
    IN: 'Indiana',
    IA: 'Iowa',
    KS: 'Kansas',
    KY: 'Kentucky',
    LA: 'Louisiana',
    ME: 'Maine',
    MD: 'Maryland',
    MA: 'Massachusetts',
    MI: 'Michigan',
    MN: 'Minnesota',
    MS: 'Missouri',
    MO: 'Montana',
    MT: 'Nebraska',
    NE: 'Nebraska',
    NV: 'Nevada',
    NH: 'New Hampshire',
    NJ: 'New Jersey',
    NM: 'New Mexico',
    NY: 'New York',
    NC: 'North Carolina',
    ND: 'North Dakota',
    OH: 'Ohio',
    OK: 'Oklahoma',
    OR: 'Oregon',
    PA: 'Pennsylvania',
    RI: 'Rhode Island',
    SC: 'South Carolina',
    SD: 'South Dakota',
    TN: 'Tennessee',
    TX: 'Texas',
    UT: 'Utah',
    VT: 'Vermont',
    VA: 'Virginia',
    WA: 'Washington',
    WV: 'West Virginia',
    WI: 'Wisconsin',
    WY: 'Wyoming'
  };

  statesReverse = _.invert(states);

  lookup = function(str) {
    var abbr, name;
    str = str != null ? str.trim() : void 0;
    if (!str) {
      return;
    }
    if (str.length === 2) {
      abbr = str.toUpperCase();
      name = states[abbr];
      if (name) {
        return {
          abbr: abbr,
          name: name
        };
      }
    } else {
      name = str.split(' ').map(function(part) {
        return _.capitalize(part);
      }).join(' ');
      abbr = statesReverse[name];
      if (abbr) {
        return {
          abbr: abbr,
          name: name
        };
      }
    }
  };

  parse = function(str) {
    var parsed, state;
    if (str == null) {
      return str;
    }
    parsed = null;
    if (state = lookup(str)) {
      parsed = new String(state.abbr);
      parsed.raw = str;
      parsed.name = state.name;
    } else {
      parsed = new String(str);
      parsed.raw = str;
      parsed.name = str;
    }
    parsed.valid = true;
    return parsed;
  };

  module.exports = {
    parse: parse,
    components: [
      {
        name: 'raw',
        type: 'string',
        description: 'Unmodified value'
      }, {
        name: 'name',
        type: 'string',
        description: 'Full name of state'
      }
    ],
    maskable: false,
    operators: ['is equal to', 'is not equal to', 'is blank', 'is not blank', 'includes', 'does not include', 'is included in', 'is not included in'],
    examples: ['TX', 'Texas', 'Quebec', 'Île-de-France']
  };

}).call(this);
