// Generated by CoffeeScript 1.9.0
(function() {
  var chrono, components, moment, parse, _;

  _ = require('lodash');

  moment = require('moment');

  chrono = require('chrono-node');

  parse = function(string) {
    var parsed, raw, results, _ref, _ref1;
    raw = (_ref = string != null ? (_ref1 = string.raw) != null ? _ref1.toString() : void 0 : void 0) != null ? _ref : string;
    results = chrono.parse(string.toString());
    if (results.length) {
      parsed = new Date(results[0].start.date());
      parsed.raw = raw;
      parsed.valid = true;
      parsed.valueOf = function() {
        return this.toString();
      };
      parsed.toString = function() {
        return this.toISOString();
      };
    } else {
      parsed = new String(raw);
      parsed.raw = raw;
      parsed.valid = false;
      parsed.valueOf = function() {
        return raw;
      };
      parsed.toString = function() {
        return raw;
      };
    }
    return parsed;
  };

  components = [
    {
      name: 'raw',
      type: 'string',
      description: 'Unmodified value'
    }
  ];

  module.exports = {
    parse: parse,
    components: components,
    operators: ['is equal to', 'is not equal to', 'is less than', 'is less than or equal to', 'is greater than', 'is greater than or equal to', 'is blank', 'is not blank', 'format is valid', 'format is invalid', 'is between', 'is not between'],
    examples: ['Sat Jun 14 2015 13:27:33 GMT-0500 (CDT)', '06/14/2015 6:27:33 PM', '2015-06-14T18:27:33Z', '2015-06-14T18:27:33.000Z']
  };

}).call(this);
