// Generated by CoffeeScript 1.9.0
(function() {
  var isValidUrl, url;

  url = require('url');

  isValidUrl = function(uri) {
    return (uri.protocol != null) && uri.protocol.match(/^http[s]?:/) && uri.slashes && uri.hostname;
  };

  module.exports = {
    parse: function(str) {
      var parsed, uri, _ref, _ref1;
      if (str == null) {
        return str;
      }
      uri = url.parse((str != null ? (_ref = str.raw) != null ? _ref.toString() : void 0 : void 0) || str);
      if (isValidUrl(uri)) {
        parsed = new String(uri.href);
        parsed.raw = (_ref1 = str.raw) != null ? _ref1 : str;
        parsed.protocol = uri.protocol.replace(/:$/, '');
        parsed.host = uri.host;
        parsed.port = uri.port;
        parsed.path = uri.pathname;
        parsed.query = uri.query;
        parsed.hash = uri.hash;
        parsed.valid = true;
        return parsed;
      } else {
        parsed = new String(str);
        parsed.raw = str.raw || str;
        parsed.valid = false;
        return parsed;
      }
    },
    components: [
      {
        name: 'raw',
        type: 'string',
        description: 'Unmodified value'
      }, {
        name: 'protocol',
        type: 'string',
        description: 'Protocol: http or https'
      }, {
        name: 'host',
        type: 'string',
        description: 'The host name (i.e. google.com)'
      }, {
        name: 'port',
        type: 'string',
        description: 'The numeric port number, if present'
      }, {
        name: 'path',
        type: 'string',
        description: 'The path on the host (i.e. /some/path/to/a/file.html)'
      }, {
        name: 'query',
        type: 'string',
        description: 'The query string (i.e. name=Joe&state=TX'
      }, {
        name: 'hash',
        type: 'string',
        description: 'The trailing hash, if present (i.e. #docs)'
      }
    ],
    maskable: false,
    operators: ['is equal to', 'is not equal to', 'is blank', 'is not blank', 'includes', 'does not include', 'is included in', 'is not included in'],
    examples: ['https://google.com', 'https://yourwebsite.com/some/file.asp?type=offer', 'http://referringurl.com/a/landing/page.html']
  };

}).call(this);
